/****************************************************************
Server.java
CS 481 - Team A
Written: Spring 1997
Revised: String 1998
Hummingbird Project - Dr. Frincke
Coded by: Pete Neisen
Revised by: Jesse C. McConnell
Description: This is a cheesy interface thrown together to display 
             hummer message forwarded to the alert interface. 
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import java.io.*;
import java.net.*;

public class Server extends Thread
{

  protected ServerSocket ListenSocket;
  protected int Port;

  public static void fail(Exception E, String Msg)
  {
    System.err.println(Msg+":"+E);
    System.exit(1);
  }

  public Server(int Port)
  {
    this.Port = Port;
    try{
      ListenSocket = new ServerSocket(Port);
    }
    catch(IOException E){
      fail(E, "Exception creating server socket");
    }
    this.start();
  }

  public void run()
  {
    try{
      while(true){
	Socket ClientSocket = ListenSocket.accept();
	Connection C = new Connection(ClientSocket);
      }
    }
    catch(IOException E){
      fail(E,"Exception listening for connections");
    }
  }
}


class Connection extends Thread
{
  protected Socket Client;
  protected DataInputStream in;
  protected DataOutputStream out;



  public Connection(Socket ClientSocket)
  {
    Client = ClientSocket;
    try{
      /* Rid of the DataInputStream and buffer it. 
      in = new DataInputStream(Client.getInputStream());
      */
      in = new DataInputStream(Client.getInputStream());
      /* The PrintStream has been deprecated and is now a PrintWriter
      out = new PrintStream(Client.getOutputStream());
      */
      out = new DataOutputStream(Client.getOutputStream());
    }
    catch(IOException E){
      try{
	Client.close();
      }
      catch(IOException E2){}
      System.err.println("Exception while getting socket streams:" +E);
      return;
    }
    this.start();
  }
  
  public void run()
  {
    String Line;
    byte buf[] = new byte[9];
    
    try{
      out.write("NO_KRB5".getBytes(),0,7);
      in.read(buf, 0, 7);
      //System.out.println(buf);
      short xmit_len = in.readShort();
      //System.out.println(xmit_len);
      buf = new byte[xmit_len];
      in.read(buf, 0, xmit_len);
      //System.out.println(buf);
      Line = new String(buf);
      //System.out.println(Line);
      Interface.AddToList(Line);
    }
    catch(IOException E){}
    finally{
      try{
	Client.close();
      }  
      catch(IOException E2){}
    }
  }
}


      







