#!&PERL& -I&INCDIR&
# -*- perl -*-
# must include the above line to use perl v5.002 on this system

##############################################################
#      Hummingbird  (Team A)
#      12/02/97
#      Jamie Marconi
#      
#  This tool is designed to parse the bdf system tool and send all
#  relevant information to its hummer.
##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use Toollib;
use Datelib qw(hhmmss yyyymmdd $datetime);


forktoBg($0);      
$logfile = "&BDF_TYPE&|";
$sleepTime = 300;

&parseData();
&delpid();


#################################################################
# This subroutine will parse the information in the log file
# and call 'ToolI'
#################################################################

sub parseData 
{
    while (!$do_exit) { 
	open (LOG,$logfile) || die "Can't open $logfile.\n";
	$_ = <LOG>;
	
	while (<LOG>) {
	    
	    chop $_;
	    
	    ($dev, $blocks, $used, $avail, $capacity, $mnt) = split(/ +/,$_);
	    if ($blocks eq "") {
		$_ = <LOG>;
		chop $_;
		($null, $blocks, $used, $avail, $capacity, $mnt) = split(/ +/,$_);
	    }
	    $msngr = join(' ', "BDF:", $dev, $capacity);
	    $msngr =~ s/%//g;
	    
	    $date =  yyyymmdd();
	    $time =  hhmmss();

	    ToolI($msngr, $date, $time, $hostname, $logfile, "bdftool");
	}
	close (LOG);
	
	sleep $sleepTime;
	
	
    }
    
}
