/*************************************************************
krb5_sock.h
HummingBird Project - Deborah A. Frincke, PhD.
Summer 1997
Coded by: Jamie Marconi
Description: This is the class definition for the base kerberized socket.
**************************************************************/
/*
  Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _krb5_sock_h
#define _krb5_sock_h

#include "config.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netinet/in.h>
#include <signal.h>
#include <netdb.h>
#include <stdio.h>

extern "C" {
#include <krb5.h>
#include <com_err.h>
}

#include <iostream.h>

#define KRB5_SOCK_VERSION "0.0"
#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 64
#endif

class krb5_sock {
 protected:
  // Data;
  char full_rmt_hname[MAXHOSTNAMELEN];
#ifdef BROKEN_STREAMS_SOCKETS
  char full_loc_hname[MAXHOSTNAMELEN];
#endif
  int sock;
  krb5_error_code retval;
  krb5_context context;
  krb5_auth_context auth_context;
  int port;
  char *service;
  struct sockaddr_in *rmt_sockaddr;
  struct sockaddr_in *loc_sockaddr;
  int sin_len;
  krb5_keytab keytab;
 

 public:
  //Methods;
  krb5_sock();
  ~krb5_sock();
  int krb5_get_fd();
  void krb5_set_fd(int new_fd);
  int krb5_create();
  int krb5_bind(char *pservice);
  int krb5_bind(int pport, char *pservice);
  int krb5_close();
};


#endif /* _krb5_sock_h */
