#! &PERL& -I&INCDIR&
#---------

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use Toollib qw($hostname);
use Datelib qw(hhmmss yyyymmdd);

open (PSR, ">> ./ftp.log") || die "Can't open file. $! $0 \n";
open (PS, "ps -efl|") 	   || die "Can't open pipe for ps. $!\n";
 
 
while (<PS>) {
 chop;
   
 ($flags,$state,$uid,$pid,$ppid,$cpu,$pri,$nice,$address,$size,
  $wchan,$stime,$data) = split(' ', $_, 13);

 if ($data =~ /ftpd/) {
    &parsePsData;
    if (!&checkForOldDaemons) {
	system "ftpmonitor -id $pid";
  	&psrMessage;
    }
 }  

}



########################################################
# Parse data from 'ps -efl'
########################################################

sub parsePsData {

  $_ = $stime;  
  $cnt = tr/a-zA-Z0-9://;

  if ($cnt > 3) { 
     ($tty,$time,$command) = split(' ',$data,3); 
  }
  else {   
     ($wday,$tty,$time,$command) = split(' ',$data,4);
     $stime = join(' ',$stime,$wday,"  ");
  }
}




################################################################
# Check for old daemons, those older than today, if found
# put in logfile and exit
################################################################
   
sub checkForOldDaemons {
$old_process = 0;
 
  @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
      
  foreach $month (@months) {
        if ($stime =~ /$month/) {
            $old_process = 1;
        print PSR "Old daemon: $uid\t$pid\t$stime\t$command\t$hostname\n";
        }
  }
$old_process;
}



################################################################
# Send a potential security risk message
################################################################

sub psrMessage {

    $date 	= yyyymmdd();
    $current_time = hhmmss(); 
    $logfile 	= "ps_efl";
    $message 	= join('', "PSR[",$pid,"]     ",$stime,"  ",$command,"   ",$hostname);
    
    ToolI($message, $date, $current_time, $hostname, $logfile, "loadAlert");
}
