#! &SH& 
# -*- sh -*-

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

if echo '\c' | grep -s c >/dev/null 2>&1
then
        ECHO_N="echo -n"
        ECHO_C=""
else
        ECHO_N="echo"
        ECHO_C='\c'
fi

FRONTEND="psql -n -e -q"

echo "================= destroying old hummer database... ==================="
destroydb \"hummer_`hostname`\"


echo "================= creating new hummer database...   ==================="
createdb \"hummer_`hostname`\"
if [ $? -ne 0 ]; then
     echo createdb failed
     exit 1
fi

echo "======================= creating new tables... ========================"
$ECHO_N "Please wait .. " $ECHO_C
$FRONTEND hummer_`hostname` < create_tables.sql > create_table.results 2>&1
        if [ `diff create_table.expected create_table.results | wc -l` -ne 0 ]
        then
                echo failed
        else
                echo ok
        fi

echo "===================== adding default values... ========================"
$ECHO_N "Please wait .. " $ECHO_C
$FRONTEND hummer_`hostname` < add_values.sql > add_values.results 2>&1
        if [ `diff add_values.expected add_values.results | wc -l` -ne 0 ]
        then
                echo failed
        else
                echo ok
        fi

echo "============================= done... ================================="

