#! &PERL&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

# demo script, has been tested with:
#  - Postgres-6.1
#  - apache_1.2
#  - mod_perl-1.0
#  - perl5.004

use CGI qw(:standard);
use Pg;
use strict;

use Sys::Hostname;
my $host = hostname();

my $conn = Pg::connectdb("dbname = hummer_$host");
( PGRES_CONNECTION_OK eq $conn->status ) || exit;
my $result;
my $inh = param('inh');

print header;
print start_html(-title=>'Kill File Modification',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple');
print "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
  h1('Kill Modification'),a({href=>"killfile__help.html"},"<H3>Help</H3>"),
  "<H4><A HREF=\"levels.shtml\">Return to Levels Configuration Page</A></H4>",
  hr,
  "</center>";

if ($inh eq "") {
  print h2('Error: Must specify inherited value');
}
else {
  $result = $conn->exec("SELECT * FROM kill_file where inh = $inh;");
  (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
  
  my @kills;
  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
    $kills[$i] = $result->getvalue($i,0);
    if ($result->getvalue($i, 1)) {
      $kills[$i] = $kills[$i] . "-" . $result->getvalue($i, 1); 
    }
    #$kills[$i] = $kills[$i] . "--" . $result->getvalue($i, 2);
  }

  if (!param('Action')) {
    print "<center>",
    "<a href=\"addkillfile.cgi?inh=$inh\">Add a New Kill File Hummer</a>",
    start_form,
    hidden(-name=>'inh',-default=>["$inh"]),
    "Hosts: ",
     popup_menu(-name=>'kills',
		-values=> [ @kills ]),
    submit('Action','Remove'),
    reset(),
    end_form,
    "</center>";
  }
  else {
    my $kills = param('kills');
    my ($start_addr, $end_addr) = split( /-/, $kills);
    
    $result = $conn->exec("delete from kill_file \n
           where \n
             start_addr = '$start_addr'\n
             and end_addr = '$end_addr' \n
             and inh = $inh;");
    # print "delete from kill_file <br>
    #           where <br>
    #             start_addr = '$start_addr'<br>
    #             and end_addr = '$end_addr' <br>
    #             and inh = $inh;<br><br>";
    (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
    
    print h2('Changes made sucessfully');
  }
}


print end_html;
  
