#! &PERL&


##############################################################
#      save_config.cgi
#
#      Hummingbird 
#      Made: 7/01/98
#      Modified: 7/01/98
#      Joel Marlow
#      
#  This script is used to save the configuration of the current hummer. It helps
#  for stability in case postgress goes down.
##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use CGI;
use Pg;
use strict;
use Socket;
use Sys::Hostname;

my $query = new CGI;
my $host = hostname();

my $domain = `domainname`;
chop $domain;
my $hname;
my $ipaddress;



open (LOAD, "save_$host.dat") or die "Cannot read file"; 

print  $query->header,
    "<html><head><TITLE>Load Hummer Configuration</TITLE></head>\n
     <BODY TEXT=black BGCOLOR=white LINK=blue VLINK=purple>\n",
    "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
    "<H1>Load Hummer Configuration </H1>",
    "<HR WIDTH=\"87%\">";

print "<H4><A HREF=\"index.html\">Return to Hummer Homepage</A></H4>";
print "<P><HR ALIGN=CENTER WIDTH=\"51%\"><br>";

my $conn = Pg::connectdb("dbname = hummer_$host");
( PGRES_CONNECTION_OK eq $conn->status ) || die "Can't Connect to DB\n";

my $result = $conn->exec("delete from accept_list;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from config_time;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from filter;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from forward_list;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from forward_peer;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from kill_file;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from levels;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from manager;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from peers;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from pgroups;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from pid;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";
my $result = $conn->exec("delete from subordinates;");
(PGRES_COMMAND_OK eq $result->resultStatus) || die "select filter:$!";


#print "<H4>START***************accept_list</H4>";
my $store;
#accept_list
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here accept_list</H4>";
  (my $filter,my $start_addr,my $end_addr,my $inh) = (split /[|]/, $store);
  $result = $conn->exec("insert into accept_list values ('$filter','$start_addr','$end_addr','$inh');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************config_time</H4>";

#config_time
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here config_time</H4>";
  my $ctime = $store;
  $result = $conn->exec("insert into config_time values ('$ctime');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************filter</H4>";

#filter
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here filter</H4>";
  (my $expression,my $date_start,my $date_end,my $time_start,my $time_end,my $trust,my $coop,my $integ,my $log,my $alert,my $inh) =split (/[|]/, $store);
  if ($date_start eq "") {$date_start = "NULL"}
  else { $date_start = "'$date_start'"; }
  if ($date_end eq "")  {$date_end = "NULL"}
  else { $date_end = "'$date_end'"; }
  if ($time_start eq "") {$time_start = "NULL"}
  else { $time_start = "'$time_start'"; }
  if ($time_end eq "") {$time_end = "NULL"}
  else { $time_end = "'$time_end'"; }
  if ($trust eq "") {$trust = "NULL"}
  else { $trust = "'$trust'"; }
  if ($coop eq "") {$coop = "NULL"}
  else { $coop = "'$coop'"; }
  if ($integ eq  "") {$integ = "NULL"}
  else { $integ = "'$integ'"; }
  if ($log eq "") {$log = "NULL"}
  else { $log = "'$log'"; }
  if ($alert eq "") {$alert = "NULL"}
  else { $alert = "'$alert'"; }
  if ($inh eq "") {$inh = "NULL"}
  else { $inh = "'$inh'"; }

  #print "$expression & $date_start & $date_end & $time_start & $time_end & $trust & $coop & $integ & $log & $alert & $inh";
  $result = $conn->exec("insert into filter values ('$expression',$date_start,$date_end,$time_start,$time_end,$trust,$coop,$integ,$log,$alert,$inh);");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************forward_list</H4>";

#forward_list
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here forward_list</H4>";
  (my $filter,my $mem,my $inh) =split (/[|]/, $store);
  $result = $conn->exec("insert into forward_list values ('$filter','$mem','$inh');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************forward_peer</H4>";

#forward_peer
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here forward_peer</H4>";
  (my $filter,my $pgroup,my $inh) =split (/[|]/, $store);
  $result = $conn->exec("insert into forward_peer values ('$filter','$pgroup','$inh');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************kill_file</H4>";

#kill_file
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here kill_file</H4>";
  (my $start_addr,my $end_addr,my $inh) =split (/[|]/, $store);
  $result = $conn->exec("insert into kill_file values ('$start_addr','$end_addr','$inh');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************levels</H4>";

#levels
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here levels</H4>";
  (my $start_addr,my $end_addr,my $trust,my $coop,my $integ,my $inh) =split (/[|]/, $store);
  $result = $conn->exec("insert into levels values ('$start_addr','$end_addr','$trust','$coop','$integ','$inh');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************manager</H4>";

#manager
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here manager</H4>";
  my $manager = $store;
 $result = $conn->exec("insert into manager values ('$manager');");
 (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
 $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************peers</H4>";

#peers
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here peers</H4>";
  (my $grp,my $mem,my $sub,my $mod) =split (/[|]/, $store);
  $result = $conn->exec("insert into peers values ('$grp','$mem','$sub','$mod');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************pgroups</H4>";

#pgroups
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here pgroups</H4>";
  (my $grp,my $mem,my $email) =split (/[|]/, $store);
  $result = $conn->exec("insert into pgroups values ('$grp','$mem','$email');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************pid</H4>";

#pid
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here pid</H4>";
  (my $name,my $pid) = split /[|]/, $store;
  #print "$name";
  #print "   next $pid";
  $result = $conn->exec("insert into pid values ('$name','$pid');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

#print "<H4>NEXT ONE***************subordinates</H4>";

#subordinates
$store = <LOAD>;
chop($store);
while ($store ne "#@")
{
  #print "<H4>Here subordinates</H4>";
  (my $hum_name,my $subordinate) =split (/[|]/, $store);
  $result = $conn->exec("insert into subordinates values ('$hum_name','$subordinate');");
  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
  $store = <LOAD>;
  chop($store);
}

print "<H4>The Configuration for this Hummer has been loaded</H4></center>";



