#! &PERL&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use CGI qw(:standard);
use Pg;
use strict;
use Socket;

use Sys::Hostname;
my $host = hostname();
my $domain = `domainname`;
chop $domain;
my $hname;
my $ipaddress;

my $conn = Pg::connectdb("dbname = hummer_$host");
( PGRES_CONNECTION_OK eq $conn->status ) || exit;

my $result = $conn->exec("select * from pgroups;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

my @groupnames;
my $i;
for ($i=0; $i < $result->ntuples; $i++) {
  $groupnames[$i] = $result->getvalue($i,0);
}
my $group;
if (!param('pgroupname')) {
  $group = $groupnames[0];
}
else {
  $group =  param('pgroupname');
}

print header;
print start_html(-title=>'Peer Interface',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple'),
  
  "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
  
  h1('Peer Interface'), "<H3><A HREF=\"peerinthelp.html\">Help</A></H3>",
  "<H4><A HREF=\"peer2peer.shtml\">Return to Peer Moderation Page</A></H4>",
    "<HR WIDTH=\"87%\">";

if (param('Action') eq "Send Message") {
  my $fqdn = $host . "." . `domainname`;
  chop $fqdn;
  my $message = param('message');
  my $to = param('peers');
  my $time =  `date +%H%M%S`;
  my $date =  `date +%Y%m%d`;


  if ($to eq 'All Members') {
    system "./PeerI -m \"$group\" -M \"$message\"";
  }
  else {
    system "./ToolI -m \"$message\" -d \"$date\" -t \"$time\" -h \"$fqdn\" -f \"$group\"  -s \"peers\"";
  }
  
  print "</center>",
  h2("Hummer Message Sent<br>From: $fqdn<br>To: $to<br>Message: $message<br>");

}
else {
  print "<B><FONT SIZE=+3>Current Peer Group is:</FONT></B>",
  
  start_form;
  
  print popup_menu(-name=>'pgroupname',
		   -values=> [ @groupnames ],
		   -onChange=>'submit()'),"<HR WIDTH=\"53%\"></center>";


  print "<CENTER><table><tr><td align = right valign=top>";
  print "<P align = left><B><FONT SIZE=+3>Peer Group Status</FONT></B></P>";

  $result = $conn->exec("select mem_addr from peers where pgroup='$group' and peer_mod=1;");
  (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
  my $modaddress = $result->getvalue(0,0);
  $hname = $host . "." . $domain;
  $ipaddress = &getaddress($hname);  
  if ($modaddress ne $ipaddress) {
      $result = $conn->exec("delete from peers where pgroup = '$group';");
      $result = $conn->exec("delete from pgroups where pgroup = '$group';");
      system "./PeerI -s \"$group\" -a \"$modaddress\"";
  }

  print "<table border=1><tr><th>Peer Group</th><th>Host Name</th><th>Host IP</th><th>Subscribed</th><th>Moderator</th></tr>\n";
  $result = $conn->exec("select * from peers where pgroup = '$group';");
  (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $grp = $result->getvalue($i,0);
      my $mem = $result->getvalue($i,1);
      my $sub = $result->getvalue($i,2);
      my $mod = $result->getvalue($i,3);
      $hosts = &getname($mem);
      print "<tr><td>$grp</td><td>$hosts</td><td>$mem</td>";
      if ($sub eq 0) { print "<td>no</td>"; }
      if ($sub eq 1) { print "<td>yes</td>"; }
      if ($mod eq 0) { print "<td>no</td>"; }
      if ($mod eq 1) { print "<td>yes</td>"; }
      print "</tr>\n";
  }
  print "</table><BR><BR>";
  print "</td><td align=left valign=top>";

  print "<P><B><FONT SIZE=+3>Level Status</FONT></B></P>";
  print "<table border=1><tr><th>Host IP</th><th>Trust</th><th>Integrity</th><th>Cooperation</th></tr>\n";
  my $result = $conn->exec("select * from peers where pgroup ='$group';");
  (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
  my @peers;
  for ($i=0; $i < $result->ntuples; $i++) {
      $peers[$i] = $result->getvalue($i,1);
  }
  for ($i=0; $i <= $#peers; $i++) {
      $result = $conn->exec("select * from message where mem_addr = '$peers[$i]' and pgroup='$group';");
      (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
      $result = $conn->exec("select * from levels where start_addr = '$peers[$i]';");
      (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
      my $trust = $result->getvalue(0,2);
      my $coop = $result->getvalue(0,3);
      my $integ = $result->getvalue(0,4);
      print "<tr>
            <td>$peers[$i]</td>
            <td>$trust</td>
            <td>$integ</td>
            <td>$coop</td>
           </tr>\n";
  }
  print "</table>";
  print "</td></tr></table></CENTER>";  
  
  print "<BR><CENTER><B><FONT SIZE=+3>Send Hummer Message to </FONT></B>";

  print  popup_menu(-name=>'peers',
		    -values=>['All Members',
			      @peers],
		    -default=>'All Members'),
  
  "<P>Enter Hummer Message Below:</P>",
  textfield(-name=>'message',
	    -size=>40), p,
  submit('Action', 'Send Message'),
  reset(),
  end_form;
}
print "</center>";




sub getstatus {
  
  my($status_num) = @_;
  my $status;
  
  if ($status_num eq "0") {
    $status = "Undefined 0";
  }
  elsif ($status_num eq "1") {
    $status = "Undefined 1";
  }
  elsif ($status_num eq "2") {
    $status = "Undefined 2";
  }
  elsif ($status_num eq "3") {
    $status = "Undefined 3";
  }
  elsif ($status_num eq "4") {
    $status = "Undefined 4";
  }
  elsif ($status_num eq "5") {
    $status = "Undefined 5";
  }
  elsif ($status_num eq "6") {
    $status = "Undefined 6";
  }
  elsif ($status_num eq "7") {
    $status = "Undefined 7";
  }
  elsif ($status_num eq "8") {
    $status = "Undefined 8";
  }
  elsif ($status_num eq "9") {
    $status = "Undefined 9";
  }
  elsif ($status_num eq "10") {
    $status = "Undefined 10";
  }
  else {
    $status = "Error";
  }

  return $status;
}

sub getaddress {
  my($hname) = @_;
  my $add  = '';
  my $addre;
  my $address=gethostbyname($hname);
  my @addr=unpack('C4',$address);
  foreach $addre (@addr) {
    $add = $add . $addre . ".";
  }
  chop $add;
  return $add;
}

sub getname {
    my($hname) = @_;

    my $n1 = index($hname,".");          
    my $s1 = substr($hname,0,$n1);                                              
    my $n2 = index($hname,".",$n1+1);
    my $s2 = substr($hname,$n1+1,$n2-($n1+1));
    my $n3 = index($hname,".",$n2+1);
    my $s3 = substr($hname,$n2+1,$n3-($n2+1));
    my $s4 = substr($hname,$n3+1);

    my @a= ($s1,$s2,$s3,$s4);
    my $addr=pack('C4',@a);

    my $names;
    my $alias;
    my $adrtype;
    my $length;
    my @address;
    ($names,$alias,$adrtype,$length,@address) = gethostbyaddr($addr,AF_INET);
    return $names;
}






