#! &PERL&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use CGI qw(:standard);
use Pg;
use strict;
use Socket;

use Sys::Hostname;
my $mhost = hostname();
my $domain = `domainname`;
chop $domain;
my $hname;
my $ipaddress;

print header;
print start_html(-title=>'Peer Group Subscription Interface',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple'),
  "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
  
  h1('Peer Group Subscription Interface');


if (param()) {
  my $host = param('host');
  my $name = param('name');
  $hname = $mhost . "." . $domain;
  $ipaddress = &getaddress($hname);
  print    "<H4><A HREF=\"peer2peer.shtml\">Return to Peer Moderation Page</A></H4>";
  print   "<HR WIDTH=\"87%\">";

  my $conn = Pg::connectdb("dbname = hummer_$mhost");
  my $res  = $conn->exec("select pgroup from pgroups where pgroup = '$name';");
  my $grpchk = $res->getvalue(0,0);
  if ($grpchk eq $name) {
      print("You are already subscribed to a group with the name \"$name\".<BR>\n",
	    "You cannot be subscribed to two or more groups with the same name.<BR>\n</center>");
      print p,

      exit;
  } 

  system "./PeerI -s \"$name\" -a \"$host\"";
  my $result = $conn->exec("select mem_addr from peers where mem_addr='$ipaddress' and pgroup = '$name';");
  my $newadd = $result->getvalue(0,0);
  if ($newadd ne $ipaddress) {
      print("Subscription to Peer Group $name at $host was UNSUCCESSFUL.\n<BR>",
	    "Check that the Peer Group \"$name\" is on host \"$host\" and that both are correct.\n<BR>",
	    "If both are correct check that the Peer Moderator has included you in the group.<BR>\n",
	    "If you are, make sure that the Peer Moderator's Peer Server is running.<BR>");
  }
  else {
      my $reslt = $conn->exec("select * from peers where pgroup = '$name';");
      print ("<P>Subscription to Peer Group $name at $host was Successful.</P><BR>");
      print ("<table border=1><tr><th>Peer Group</th><th>Host Name</th>",
	     "<th>Host IP</th><th>Subscribed</th><th>Moderator</th></tr>\n");
      my $i;
      my $hosts;
      for ($i=0; $i < $reslt->ntuples; $i++) {
	  my $grp = $reslt->getvalue($i,0);
	  my $mem = $reslt->getvalue($i,1);
	  my $sub = $reslt->getvalue($i,2);
	  my $mod = $reslt->getvalue($i,3);
	  $hosts = &getname($mem);
	  print "<tr><td>$grp</td><td>$hosts</td><td>$mem</td>";
	  if ($sub eq 0) { print "<td>no</td>"; }
	  if ($sub eq 1) { print "<td>yes</td>"; }
	  if ($mod eq 0) { print "<td>no</td>"; }
	  if ($mod eq 1) { print "<td>yes</td>"; }
	  print "</tr>\n";
      }
      print "</table><BR><BR><BR>";
  }
print "<H4><A HREF=\"peer2peer.shtml\">Return to Peer Moderation Page</A></H4>";
}
else {
  print a({href=>"peer_subscr_help.html"},"<H3>Help</H3>"),
  "<H4><A HREF=\"peer2peer.shtml\">Return to Peer Moderation Page</A></H4>",
  
  "<HR WIDTH=\"87%\">",
  "<B><I><FONT SIZE=+2>Enter the Peer Group information</FONT></I></B>",
  
  start_form,
  
  "Name of the Peer Group:", textfield(-name=>'name',
		     -size=>'30'),br,

  "Hostname of the moderator:", textfield(-name=>'host',
		      -size=>'30'),br,
  
  submit(-name=>'Subscribe'),
  reset(),
  button(-value=>'Cancel',
	 -onclick=>"history.back()"),
  
  end_form;
}
print p,
  "</center>";

sub getaddress {
    my($hname) = @_;
    my $add  = '';
    my $addre;
    my $address=gethostbyname($hname);
    my @addr=unpack('C4',$address);
    foreach $addre (@addr) {
	$add = $add . $addre . ".";
    }
    chop $add;
    return $add;
}
  
sub getname {
    my($hname) = @_;
    
    my $n1 = index($hname,".");          
    my $s1 = substr($hname,0,$n1);                                              
    my $n2 = index($hname,".",$n1+1);
    my $s2 = substr($hname,$n1+1,$n2-($n1+1));
    my $n3 = index($hname,".",$n2+1);
    my $s3 = substr($hname,$n2+1,$n3-($n2+1));
    my $s4 = substr($hname,$n3+1);

    my @a= ($s1,$s2,$s3,$s4);
    my $addr=pack('C4',@a);

    my $names;
    my $alias;
    my $adrtype;
    my $length;
    my @address;
    ($names,$alias,$adrtype,$length,@address) = gethostbyaddr($addr,AF_INET);
    return $names;
}

