/****************************************************************
Print_Error.C
CS 481 - Team E
Spring 1998
Hummingbird Project - Dr. Frincke
Coded by: Jamie Marconi
Description: Formats and prints an error message to stderr
             Prints Time, id string (prog), pid, and then Error_String
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

static char Print_Error_C[] = "$Id: Print_Error.C,v 1.1 1998/03/09 04:37:23 marc9442 Exp $";

#include "Print_Error.h"

/**********
Function: Print_Error
Purpose:   Formats and prints an error message to stderr
           Prints Time, id string (prog), pid, and then Error_String
	   Error_String is a printf like string followed by the varibles used.
**********/

int Print_Error(char *prog, char *Error_String, ...)
{
  // Get the date, and set up the varible arguments stuff
  char *date_str;
  date_str = new char[20];
  struct tm *time_sct;
  time_t t;
  t = time(NULL);
  va_list argp;

  // Format the time
  time_sct = localtime(&t);
  strftime(date_str, 20, "%b %d %T", time_sct);

  // Print out the first part of the error message
  fprintf(stderr, "%s %s[%i]: ", date_str, prog,  getpid());
  
  // let the system calls finish out the rest of the arguments.
  va_start(argp,Error_String);
  vfprintf(stderr, Error_String, argp);
  va_end(argp);
  fprintf(stderr, "\n");
  fflush(stderr);
  delete [] date_str;

  return 0;
}

