/******************************************************************
sock_cli.h
HummingBird Project - Deborah A. Frincke, PhD.
Spring 1998
Coded by: Jamie Marconi
Description: This class is used for client connections.  It
is also used to hand off server connections to a socket after a connection
has been authenicated.
*******************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _sock_cli_h
#define _sock_cli_h

#include "sock.h"     // socket base class

class sock_cli: public sock
{
 private:
  // Data;


  // Methods;
  
 public:
  sock_cli();

  sock_cli(int asock);
  sock_cli(int asock, char* pservice);

  sock_cli(char *remote_host, int port);
  sock_cli(char *remote_host, char* pservice);
  sock_cli(char *remote_host, int port, char* pservice);
 
  ~sock_cli();

  void set_names(char *keytab, char *principal);

  int connect(char *remote_host, int port, char* pservice);
  int connect(char *remote_host, char* service);
  int connect(char *remote_host, int port);

};

#endif /* _sock_cli */
  
