#! &PERL& -I&INCDIR&
# -*- perl -*-
# must include the above line to use perl v5.002 on this system

 ##############################################################
 #      Hummingbird  (Team A)
 #      12/02/97
 #      Jamie Marconi
 #      
 #  This tool is designed to parse the uptime system tool and 
 #  send the one, five, and fifteen minute loads to its hummer.
 ##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

 use Toollib;
 use Datelib qw(hhmmss yyyymmdd $datetime);
 
  
 forktoBg($0);      
 $logfile = "uptime|";
 $sleepTime = 300;

 &parseData();
 &delpid();


#################################################################
# This subroutine will parse the information in the log file
# and call 'ToolI'
#################################################################

sub parseData {
    
    while (!$do_exit) { 
	open (LOG,$logfile) || die "Can't open $logfile.\n";
	
	$line = <LOG>;

	close (LOG);

	chop $line;

# uptime has a few possible output formats	
#
# 2:50pm  up 31 day(s), 32 min(s),  2 users,  load average: 0.10, 0.13, 0.11
# 9:40am  up  7 days,   1:19,       3 users,  load average: 1.21, 1.06, 1.09

	@sline = split(/ +/,$line);

        # But that last three are always the load
	$msngr = "$sline[$#sline-2] $sline[$#sline-1] $sline[$#sline]";	
	$msngr =~ s/,//g;

	$msngr = join(' ', "LOAD:", $msngr);
	
	$date =  yyyymmdd();
	$time =  hhmmss();

	ToolI($msngr, $date, $time, $hostname, "uptime", "uptimetool");
	
	sleep $sleepTime;

    }
    
}
